=== debian/changelog ===
android-platform-tools (29.0.6-4ubuntu1) jammy; urgency=medium

  * Disable LTO, these flags are not appropriate for the target 
    toolchain. This package will still FTBFS with glibc 2.34 due to 
    assumptions about MINSIGSTKSZ being a constant, but checkpoint this 
    to the archive anyway.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Feb 2022 16:25:06 -0800

android-platform-tools (29.0.6-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Jan 2022 18:43:43 +0900

android-platform-tools (29.0.6-4~exp2) experimental; urgency=medium

  * Team upload.
  * debian/control:
    - Add B-D python3 for [amd64 i386 arm64], which requires to build
      libart.

 -- Roger Shimizu <rosh@debian.org>  Wed, 26 Jan 2022 02:27:18 +0900

android-platform-tools (29.0.6-4~exp1) experimental; urgency=medium

  * Team upload.
  * debian/control:
    - Remove unnecessary B-D: python3.
  * debian/copyright:
    - Add my entry.
  * debian/source/lintian-overrides:
    - Add very-long-line-length-in-source-file
    - Add ancient-libtool

 -- Roger Shimizu <rosh@debian.org>  Wed, 26 Jan 2022 01:53:58 +0900

android-platform-tools (29.0.6-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/control:
    - Use gcc for Arch that do not have clang support.
  * Use gcc for assembly on armel to fix ftbfs:
    - debian/external/boringssl/libcrypto.mk
    - debian/external/libunwind/libunwind.mk

 -- Roger Shimizu <rosh@debian.org>  Tue, 25 Jan 2022 19:54:01 +0900

android-platform-tools (29.0.6-3~exp3) experimental; urgency=medium

  * Team upload.
  * debian/rules:
    - Disable libdexfile for armel and armhf.

 -- Roger Shimizu <rosh@debian.org>  Tue, 25 Jan 2022 01:50:38 +0900

android-platform-tools (29.0.6-3~exp2) experimental; urgency=medium

  * Team upload.
  * debian/control:
    - Remove unnecessary B-D: maven-repo-helper.

 -- Roger Shimizu <rosh@debian.org>  Mon, 24 Jan 2022 18:07:50 +0900

android-platform-tools (29.0.6-3~exp1) experimental; urgency=medium

  * Team upload.
  * debian: Remove legacy mips Arch support.
  * debian/control:
    - Add Arch for adb and fastboot: mipsel, mips64el.
    - Remove unnecessary B-D: dh-exec, dpkg-dev, p7zip-full.
  * debian/rules:
    - Support to build adb and fastboot for Archs other than amd64.
  * debian/scripts:
    - Update get-orig-source to get perf data and run in parallel.

 -- Roger Shimizu <rosh@debian.org>  Mon, 24 Jan 2022 01:37:17 +0900

android-platform-tools (29.0.6-2) unstable; urgency=medium

  * Team upload.
  * debian/control:
    - Remove unused B-D: debhelper (>= 11).
    - Use clang for all ARCHs.
  * debian/patches:
    - Update to adapt patch requirement for gbp pq command:
      + debian/patches/system/core/stub-out-fastdeploy.patch
    - To fix ftbfs issues (Closes: #999334):
      + Update: debian/patches/art/fix-standard-namespace-errors.patch
      + Update: debian/patches/system/core/add-missing-headers.patch
      + Add: debian/patches/system/core/fix-standard-namespace-errors.patch
    - Cherry-pick patch from upstream:
      + Switch to an assembler macro for CFI_RESTORE_STATE_AND_DEF_CFA.

 -- Roger Shimizu <rosh@debian.org>  Sun, 23 Jan 2022 18:03:24 +0900

android-platform-tools (29.0.6-1) unstable; urgency=medium

  * Team upload
  * New upstream version 29.0.6

 -- Prateek Ganguli <prateek.ganguli@gmail.com>  Thu, 20 May 2021 10:00:00 +0530

android-platform-tools (29.0.4-1) UNRELEASED; urgency=medium

  * New upstream version 29.0.4

 -- Prateek Ganguli <prateek.ganguli@gmail.com>  Thu, 06 May 2021 19:03:00 +0530

android-platform-tools (10.0.0+r36-1) UNRELEASED; urgency=medium

  * Initial release.

 -- Chirayu Desai <chirayudesai1@gmail.com>  Thu, 28 Jan 2021 16:35:48 +0530
