=== debian/control ===
Source: android-platform-tools
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
Uploaders: Chirayu Desai <chirayudesai1@gmail.com>
Build-Depends:
 bash-completion,
 clang [amd64 i386 armel armhf arm64 mipsel mips64el ppc64el s390x powerpc ppc64 sparc64 riscv64],
 debhelper-compat (= 13),
 help2man,
 libicu-dev [amd64 i386 armel armhf arm64],
 liblz4-dev [amd64 i386 armel armhf arm64],
 libpcre3-dev,
 libpng-dev,
 libsquashfuse-dev,
 python3 [amd64 i386 arm64],
 zlib1g-dev [amd64 i386 armel armhf arm64],
Build-Depends-Arch:
 libgtest-dev [amd64 i386 armel armhf arm64],
 liblzma-dev,
 libsafe-iop-dev [amd64 i386 armel armhf arm64 mipsel mips64el],
 libusb-1.0-0-dev [amd64 i386 armel armhf arm64],
 pandoc,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/android-tools-team/android-platform-tools.git
Vcs-Browser: https://salsa.debian.org/android-tools-team/android-platform-tools
Homepage: https://developer.android.com/studio/releases/platform-tools

Package: adb
Architecture: amd64 i386 armel armhf arm64
Multi-Arch: foreign
Depends: android-sdk-platform-tools-common (>= 28.0.2~),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: android-tools-adb (<< 6.0~)
Replaces: android-tools-adb (<< 6.0~)
Provides: android-tools-adb
Description: Android Debug Bridge
 A versatile command line tool that lets you communicate with an emulator
 instance or connected Android-powered device.
 .
 This package recommends "android-sdk-platform-tools-common" which contains
 the udev rules for Android devices. Without this package, adb and fastboot need
 to be running with root permission.

Package: fastboot
Architecture: amd64 i386 armel armhf arm64
Multi-Arch: foreign
Depends: android-sdk-platform-tools-common (>= 28.0.2~),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: android-sdk-platform-tools
Breaks: android-tools-fastboot (<< 6.0~)
Replaces: android-tools-fastboot (<< 6.0~)
Provides: android-tools-fastboot
Description: Android fastboot tool
 A command line tool for flashing an Android device, boot an Android device to
 fastboot mode, etc..

Package: etc1tool
Architecture: amd64 i386 armel armhf arm64 mipsel mips64el
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: ETC1 conversion tool
 etc1tool is a command line utility that lets you encode PNG images to
 the ETC1 compression standard and decode ETC1 compressed images back
 to PNG. It is part of the Android SDK for working with media files
 for game apps. The standard for the ETC1 texture format is here:
 http://www.khronos.org/registry/gles/extensions/OES/OES_compressed_ETC1_RGB8_texture.txt

Package: dmtracedump
Architecture: any
Multi-Arch: foreign
Depends: graphviz,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Generates graphical call-stack diagrams from Android trace logs
 `dmtracedump` generates the call stack data as a tree diagram, where
 each node represents a method call. It shows call flow (from parent
 node to child nodes) using arrows.

Package: hprof-conv
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: HPROF Converter
 The hprof-conv tool converts the HPROF file that is generated by the Android
 SDK tools to a standard format so you can view the file in a profiling tool of
 your choice.
